
local addon, ns = ...

local L = ns.L

-------SomePrepare Tools(Jobs) ---------

function table_copy(table)
	local NewTable = {}
	if table then
		for k, v in pairs(table) do
			NewTable[k] = v 
		end
	end
	return NewTable;
end

function table_same(table1, table2)
	local leng1, leng2 = table_leng(table1), table_leng(table2)
	if leng1 ~= leng2 then return false end 

	if table1 and table2 then
		for k, v in pairs(table1) do
			-- print '-----'
			-- print (table2[k])
			-- print (v)
			if not (table2[k] == v) then
				-- print '!!!!!!!!'
				-- print ("不符合的是"..v.."...."..table2[k])
				return false
			end
		end
	end
	return true
end

function table_keys(t)
	local tbKeys = {}
	local i = 1
	for k, v in pairs(t) do
		tbKeys[i] = k
		i = i + 1
	end	
	return tbKeys;
end

function table_leng(t)
  local leng=0
  for k, v in pairs(t) do
    leng=leng+1
  end
  return leng;  --return int
end

function GetTrueNum(table)
	local i = 0
	for k, v in pairs(table) do 
		if v then 
			i = i + 1
		end 
	end 
	return i
end 

------------------
local myGUI = {}

myGUI.frame1 = CreateFrame("Frame", "MainGUI", InterfaceOptionsFrame)
myGUI.frame1.name = "Plate|cff00FFFFColor|r"

myGUI.frame2 = CreateFrame( "Frame", "AURAGUI", myGUI.frame1); 
myGUI.frame2.name = "光环模块"
myGUI.frame2.parent = myGUI.frame1.name

myGUI.frame3 = CreateFrame( "Frame", "AURAGUI2", myGUI.frame1); 
myGUI.frame3.name = "|cff3399FF光环黑名单|r"
myGUI.frame3.parent = myGUI.frame1.name

local function newFont(offx, offy, createframe, anchora, anchroframe, anchorb, text, fontsize)
	local font = createframe:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	font:SetPoint(anchora, anchroframe, anchorb, offx, offy)
	font:SetText(text)
	font:SetFont("fonts\\ARHei.ttf", fontsize, "OUTLINE")	
	return font
end

local function newFontSmall(x, y, createframe, anchroframe, text)
	local font = createframe:CreateFontString(nil, "OVERLAY");
	font:SetFontObject("GameFontHighlight");
	font:SetPoint("TOPLEFT", anchroframe, "TOPLEFT", x, y);   
	font:SetText(text);
	return font
end


local function newLine(createframe, anchroframe, offx, offy, width)
	local line = createframe:CreateTexture(nil, "BACKGROUND")
	line:SetColorTexture(.4,.4,.4,.8);
	line:SetSize(width, 1.5)
	line:SetPoint("BOTTOMLEFT", anchroframe, "BOTTOMLEFT", offx, offy)
	return line
end

local function newCheckbox(x, y, fatherframe, label, description, anchroframe, varname)
	local check = CreateFrame("CheckButton", "PlateColorCheck" .. label, fatherframe, "InterfaceOptionsCheckButtonTemplate")
	check:SetPoint("TOPLEFT", anchroframe, "TOPLEFT", x, y)
	check.label = _G[check:GetName() .. "Text"]
	check.label:SetText(label)
	check.tooltipText = description

	
	local CheckStatus = PlateColorDB[varname]
	check:SetChecked(CheckStatus)

	check:SetScript("OnClick", function ( ... )
		PlateColorDB[varname] = check:GetChecked()
	end)
	-- check.tooltipRequirement = description
	return check
end

local function newSlider(x, y, SliderName, minValue, maxValue, curValue, valueStep, lowText, highText, upText, tipText, anchroframe, fatherframe, varname, varformat, Cvar,Cvarb,namefont)
	local pSlider = CreateFrame("Slider", "Slider"..SliderName , fatherframe, "OptionsSliderTemplate" );
	pSlider:SetPoint("TOPLEFT", anchroframe, "TOPLEFT", x, y);
	pSlider:SetMinMaxValues(minValue, maxValue);
	pSlider:SetValue(curValue);
	pSlider:SetValueStep(valueStep);
	pSlider:SetObeyStepOnDrag(true);
	pSlider.textLow = _G["Slider"..SliderName.."Low"]
	pSlider.textHigh = _G["Slider"..SliderName.."High"]
	pSlider.text = _G["Slider"..SliderName.."Text"]
	pSlider.textLow:SetText(lowText)
	pSlider.textHigh:SetText(highText)
	if varname then 
		pSlider:SetValue(PlateColorDB[varname])
	end
	pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")

	pSlider:SetScript("OnValueChanged", function(pSlider,event,arg1) 
		pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")
		if varname then 
			PlateColorDB[varname] = tonumber(string.format(varformat,pSlider:GetValue()))
		end
		if Cvar then
			SetCVar(Cvar, PlateColorDB[varname])
			if Cvarb then
			SetCVar(Cvarb, PlateColorDB[varname])
			end
		end
		if namefont then
			local fontline = nil
			if PlateColorDB.name == true then
				fontline = "OUTLINE"
			else
				fontline = nil
			end
			local function SetFont(obj, optSize) 
			local fontName, _,fontFlags  = obj:GetFont() 
			obj:SetFont(fontName,optSize,fontline) 
			obj:SetShadowOffset(0, 0) 
			end
			SetFont(SystemFont_LargeNamePlate,PlateColorDB[varname])
			SetFont(SystemFont_NamePlate,PlateColorDB[varname]) 
			SetFont(SystemFont_LargeNamePlateFixed,PlateColorDB[varname]) 
			SetFont(SystemFont_NamePlateFixed,PlateColorDB[varname]) 
			SetFont(SystemFont_NamePlateCastBar,PlateColorDB[varname])
		end
	end)
	pSlider.tooltipText = tipText
	-- body
	return pSlider
end

local function CreateHealthValueDropDown(fatherframe, anchroframe, x, y)
	local dctMenu = {
		[0] = "不显示";
		[1] = "数值";
		[2] = "百分比100%";
		[3] = "百分比100.0%";
		[4] = "同时显示100W-100%";
		[5] = "同时显示100W-100.0%"
 	}
	
	function WPDropDownDemo_Menu(self, level, menuList)
	 local info = UIDropDownMenu_CreateInfo()
	 local DetailType = PlateColorDB["DetailType"]
	 info.func = self.SetValue

	 info.text, info.checked, info.arg1, info.arg2 = "不显示", DetailType == 0, 0, dctMenu[0]
	 UIDropDownMenu_AddButton(info)
	 info.text, info.checked, info.arg1, info.arg2 = "数值", DetailType == 1, 1, dctMenu[1]
	 UIDropDownMenu_AddButton(info)
	 info.text, info.checked, info.arg1, info.arg2 = "百分比100%", DetailType == 2, 2, dctMenu[2]
	 UIDropDownMenu_AddButton(info)
	 info.text, info.checked, info.arg1, info.arg2 = "百分比100.0%", DetailType == 3, 3, dctMenu[3]
	 UIDropDownMenu_AddButton(info)
	 info.text, info.checked, info.arg1, info.arg2 = "100W-100%", DetailType == 4, 4, dctMenu[4]
	 UIDropDownMenu_AddButton(info)
	 info.text, info.checked, info.arg1, info.arg2 = "100W-100.0%", DetailType == 5, 5, dctMenu[5]
	 UIDropDownMenu_AddButton(info)
	end

	if not fatherframe.dropDown then 
		fatherframe.dropDown = CreateFrame("Frame", "WPDemoDropDown", fatherframe, "UIDropDownMenuTemplate")
		fatherframe.dropDown:SetPoint("TOPLEFT", anchroframe, "TOPLEFT", x, y)
		UIDropDownMenu_SetWidth(fatherframe.dropDown, 150) -- Use in place of dropDown:SetWidth
		-- Bind an initializer function to the dropdown; see previous sections for initializer function examples.
		UIDropDownMenu_SetText(fatherframe.dropDown, "血量:"..dctMenu[PlateColorDB["DetailType"]])
		UIDropDownMenu_Initialize(fatherframe.dropDown, WPDropDownDemo_Menu)

		function fatherframe.dropDown:SetValue(var1, var2, checked)
			PlateColorDB["DetailType"] = var1
			UIDropDownMenu_SetText(fatherframe.dropDown, "血量:"..var2)
		 	CloseDropDownMenus()
		end	
	end
end

local function CreateColorBlock(parent, anchorframe, x, y)
    parent.color = parent:CreateTexture(nil, "BACKGROUND")
    parent.color:SetPoint("TOPLEFT", anchorframe, "TOPLEFT", x, y)
    parent.color:SetSize(70, 15)
    parent.color:SetColorTexture(PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b)
    
    parent.btn = CreateFrame("Button", nil, parent, "GameMenuButtonTemplate");
    parent.btn:SetPoint("TOPLEFT", anchorframe, "TOPLEFT", x, y);
    parent.btn:SetSize(70, 15);
    parent.btn:SetAlpha(0)
    parent.btn:SetNormalFontObject("GameFontNormalLarge");
    parent.btn:SetHighlightFontObject("GameFontHighlightLarge");

    local onUpdate = function(restore)
        local r, g, b = ColorPickerFrame:GetColorRGB()
        parent.color:SetColorTexture(r, g, b)
        PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b = r,g,b
    end

    local onCancel = function()
        local r, g, b = ColorPicker_GetPreviousValues()
        parent.color:SetColorTexture(r, g, b)
        PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b = r,g,b
    end

    parent.btn:SetScript("OnClick", function(self, button, down)
       local r,g,b = PlateColorDB.color[parent.name].r,PlateColorDB.color[parent.name].g,PlateColorDB.color[parent.name].b
       ColorPickerFrame.func = onUpdate
       ColorPickerFrame.previousValues = {r = r, g = g, b = b}
       ColorPickerFrame.cancelFunc = onCancel
       ColorPickerFrame:SetColorRGB(r, g, b)
       ColorPickerFrame:Show() 
    end)
--[[
    parent.btn:SetScript("OnEnter", function(self)
        GameTooltip:SetOwner(self, "ANCHOR_CURSOR ", 20, -20)
        GameTooltip:SetText(parent.name)
        GameTooltip:Show()
    end)
    parent.btn:SetScript("OnLeave", function(self)
        GameTooltip:Hide()
    end)]]
end
local function CreateColorFrame(name, parent)
    local f = CreateFrame("Frame", nil, parent)
    f.name = name
    f.r, f.g, f.b, f.a = unpack(PlateColorDB.color[name])
    f.Create = CreateColorBlock
    return f
end

local function CreateColorBlocks(parent, anchorFrame, x, y)
	local rgb0 = CreateColorFrame("rgb0", parent)
    rgb0:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb0:Create(anchorFrame, x, y + 34)
	
    local rgb1 = CreateColorFrame("rgb1", parent)
    rgb1:SetPoint("TOPLEFT", anchorFrame, "TOPLEFT", x, y)
    rgb1:Create(anchorFrame, x, y)
    
    local rgb2 = CreateColorFrame("rgb2", parent)
    rgb2:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb2:Create(anchorFrame, x, y - 34)
	
	local rgb3 = CreateColorFrame("rgb3", parent)
    rgb3:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb3:Create(anchorFrame, x, y - 68)
	
	local rgb4 = CreateColorFrame("rgb4", parent)
    rgb4:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb4:Create(anchorFrame, x, y - 102)
	
	local rgb5 = CreateColorFrame("rgb5", parent)
    rgb5:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb5:Create(anchorFrame, x, y - 136)
	
	local rgb6 = CreateColorFrame("rgb6", parent)
    rgb6:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb6:Create(anchorFrame, x, y - 170)
	
	local rgb7 = CreateColorFrame("rgb7", parent)
    rgb7:SetPoint("TOPLEFT", rgb1, "TOPLEFT", x, y)
    rgb7:Create(anchorFrame, x, y - 204)

end

local function newHelpBtn(x, y, fatherframe, anchorframe, text)
	local helpbtn = CreateFrame("Button", nil, fatherframe);
	helpbtn:SetPoint("BOTTOMLEFT", anchorframe, "BOTTOMRIGHT", x , y);  
	helpbtn:SetSize(35,35);
	helpbtn:SetText(nil)
	helpbtn:SetNormalTexture("Interface\\common\\help-i")
	helpbtn:SetScript("OnEnter", function(self, button, down)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetText(text)
		GameTooltip:Show()
	end)
	helpbtn:SetScript("OnLeave", function(self, button, down)
		GameTooltip:Hide()
	end)
	return helpbtn
end

local frame, button
frame = CreateFrame("Frame", "zhichiFrame", InterfaceOptionsFrame, "UIPanelDialogTemplate")
frame.Title:SetTextColor(1,1,1)
frame.Title:SetText("感谢支持")
frame:SetWidth(210)
frame:SetHeight(420)
frame:SetClampedToScreen(true)
frame:SetFrameStrata("DIALOG")
frame:SetPoint("TOPLEFT",InterfaceOptionsFrame,"TOPRIGHT", -10, 0)  
frame:SetAlpha(1)
frame:Hide()
button = CreateFrame("Button", nil, frame)
button:SetSize(190, 380)
button:SetPoint("TOPLEFT",11,-30)
button:SetNormalTexture("Interface\\Addons\\PlateColor\\111.tga")

local function CreatePanel(frame)
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("恢复默认并重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 442, 25)
	clear:SetScript("OnClick", function()
		PlateColorDB = DefaultDB
		ReloadUI()
	end)
	local zhichi = CreateFrame("Button", "AddUIzhichi", frame, "UIPanelButtonTemplate")
	zhichi:SetText("赞助")
	zhichi:SetWidth(92)
	zhichi:SetHeight(24)
	zhichi:SetPoint("TOPLEFT", 330, 25)
	zhichi:SetScript("OnClick", function()
		 ToggleFrame(zhichiFrame);
	end)
	local pcrl = CreateFrame("Button", "AddUIpcrl", frame, "UIPanelButtonTemplate")
	pcrl:SetText("重载")
	pcrl:SetWidth(92)
	pcrl:SetHeight(22)
	pcrl:SetPoint("BOTTOMRIGHT", -200, -36)
	pcrl:SetScript("OnClick", function()
		 ReloadUI()
	end)
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMLEFT", 40, -30)
	qqun:SetText("斗鱼:323075       QQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	local ppc = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ppc:SetPoint("TOPRIGHT", -5, -5)
	ppc:SetText("|cff00FF7F/pc|r快速打开此界面")
	ppc:SetJustifyH("RIGHT")
	ppc:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')
	
	
	--newFont(offx, offy, createframe, anchora, anchroframe, anchorb, text, fontsize)
	PlateColor = newFont(16, -15 , frame, "TOPLEFT", frame, "TOPLEFT", "PlateColor", 30)
	PlateColor2 = newFont(0, 5 , frame, "BOTTOMLEFT", PlateColor, "BOTTOMRIGHT", "源生姓名版增强", 15)
	
	--
	namec = newCheckbox(16, -60, frame, "姓名版名字描边", "给姓名版和姓名版施法条字体加描边", frame, "name")
	texturec = newCheckbox(16, -90, frame, "姓名版材质美化", "给材质做美化", frame, "texture")
	arrowc = newCheckbox(16, -120, frame, "姓名版右侧箭头", "当前目标右侧蓝色箭头", frame, "arrow")
	daduanc = newCheckbox(16, -150, frame, "施法条打断名字", "目标被打断时施法条上显示是谁打断的", frame, "daduan")
	chc = newCheckbox(16, -180, frame, "仇恨变色", "仇恨变色总开关,在色块设置具体颜色", frame, "ch")
	mytargetc = newCheckbox(16, -210, frame, "选中变色", "当前目标颜色", frame, "mytarget")
	sfc = newCheckbox(16, -240, frame, "施法预警", "怪物读条时,姓名版显示施法目标是谁", frame, "sf")
	pvpc = newCheckbox(16, -270, frame, "被集火预警(PvP)", "玩家如果目标是你,姓名版会显示你的名字", frame, "pvp")
	boomc = newCheckbox(16, -300, frame, "|cff00FF7F易爆助手|r", "出现易爆球时隐藏|cff00FF7F除了当前目标和读条怪|r的其他血条", frame, "boom")
	whitec = newCheckbox(180, -60, frame, "姓名版白色名字", "姓名版名字变成白色", frame, "white")
	casttimec = newCheckbox(180, -90, frame, "姓名版施法时间", "姓名版施法条显示施法时间", frame, "casttime")
	nameonlyc = newCheckbox(180, -120, frame, "友方血条缩放", "|cff00FF7F伪名字模式,把友方的血条缩放到很小,关闭此项重载界面恢复|r", frame, "nameonly")
	
	CreateHealthValueDropDown(frame, frame, 0, -350)
	hpcentc = newCheckbox(16, -380, frame, "居中显示生命值", "居中显示生命值,默认在右侧\n|cff00FF7F更改此项需要重载界面|r", frame, "hpcent")
	num = newSlider(25, -430, "生命值文字大小", 0.5, 2, 1, 0.1, " ",  " ","生命值文字大小","生命值文字大小(倍数缩放)", frame, frame, "num", "%.1f")
	
	namefont = newSlider(225, -360, "名字大小", 1, 30, 12, 1, " ",  " ","|cff00FF7F名字大小|r","包含姓名版施法条字体,|cff00FF7F设置此项后最好重载界面,不然名字位置会不一样|rBLZ默认为12", frame, frame, "namefont", "%d",_,_,"namefont")
	powerc = newCheckbox(215, -380, frame, "个人资源条能量值", "只有能量低于200的职业才起作用,例如法力值很多没必要监控", frame, "po")
	mypotext = newSlider(225, -430, "个人资源数值大小", 0.5, 2, 1, 0.1, " ",  " ","个人资源数值大小","个人资源数值大小(倍数缩放)", frame, frame, "mypotext", "%.1f")
	
	killtexturec = newCheckbox(415, -350, frame, "显示斩杀分割线", "用竖线区分斩杀和非斩杀血量", frame, "killtexture")
	autoc = newCheckbox(415, -380, frame, "自动判断斩杀线", "根据职业不同自动判断斩杀线", frame, "auto")
	KillPerc = newSlider(425, -430, "手动斩杀线", 0, 100, 0, 1, " ",  " ","手动斩杀线","需要关闭自动斩杀线后才能手动", frame, frame, "KillPer", "%d")
	
	cvarc = newFont(16, -450 , frame, "TOPLEFT", frame, "TOPLEFT", "CVars", 20)
	CvarHelp = newHelpBtn(0, -7, frame, cvarc, "|cff00FF7F以下选项为会上传到服务器,卸载插件依然生效\n如果你想卸载本插件,请先拖到默认数值|r")
	Cvarxian = newLine(frame, cvarc, 90, 5, 500)
	nScale = newSlider(25, -500, "姓名版缩放", 0.5, 2, 0.7, 0.1, " ",  " ","姓名版缩放","姓名版大小全局缩放,默认1", frame, frame, "nScale", "%.1f", "nameplateGlobalScale")
	tScale = newSlider(25, -540, "选中目标缩放", 0.5, 2, 1, 0.1, " ",  " ","选中缩放","当前目标大小缩放,默认1.2", frame, frame, "tScale", "%.1f", "nameplateSelectedScale","nameplateLargerScale")
	ov = newSlider(225, -500, "垂直间距", 0.1, 1.5, 0.8, 0.1, " ", " ", "血条垂直间距", "默认1.1推荐0.8", frame, frame, "ov", "%.1f", "nameplateOverlapV")
	oh = newSlider(225, -540, "水平间距", 0.1, 1.5, 0.6, 0.1, " ", " ", "血条水平间距", "默认0.8推荐0.6", frame, frame, "oh", "%.1f", "nameplateOverlapH")
	AlphaMult = newSlider(425, -500, "障碍物透明度", 0.1, 1, 1, 0.1, " ",  " ","障碍物透明度","障碍物后姓名版透明度,默认1", frame, frame, "AlphaMult", "%.1f", "nameplateOccludedAlphaMult")
	MaxAlpha = newSlider(425, -540, "姓名版透明度", 0.1, 1, 1, 0.1, " ",  " ","非当前透明度","非当前选中目标透明度,默认1", frame, frame, "MaxAlpha", "%.1f", "nameplateMaxAlpha","nameplateMinAlpha")
	
	CreateColorBlocks(frame, frame, 380, -60)
	rbg0 = newFont(460, -26 , frame, "TOPLEFT", frame, "TOPLEFT", "全局颜色", 16)
	rbg1 = newFont(460, -60 , frame, "TOPLEFT", frame, "TOPLEFT", "低仇恨", 16)
	rbg2 = newFont(460, -94 , frame, "TOPLEFT", frame, "TOPLEFT", "仇恨是你", 16)
	rbg3 = newFont(460, -128 , frame, "TOPLEFT", frame, "TOPLEFT", "仇恨不稳", 16)
	rbg4 = newFont(460, -162 , frame, "TOPLEFT", frame, "TOPLEFT", "仇恨高", 16)
	rbg5 = newFont(460, -196 , frame, "TOPLEFT", frame, "TOPLEFT", "你的目标", 16)
	rbg6 = newFont(460, -230 , frame, "TOPLEFT", frame, "TOPLEFT", "名字|cffFFFFFF(怨毒/鼓舞等)|r", 16)
	rbg7 = newFont(460, -264 , frame, "TOPLEFT", frame, "TOPLEFT", "斩杀", 16)
	
	frame:SetScript("OnShow", nil)
end


myGUI.frame1:SetScript("OnShow", function(frame)
	CreatePanel(frame)
end)


local dctTempIcon = {}
local dctTempInfo = {}

myGUI.frame2:SetScript("OnShow", function(frame)
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("恢复默认并重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 442, 25)
	clear:SetScript("OnClick", function()
		PlateColorDB = DefaultDB
		ReloadUI()
	end)
	local zhichi = CreateFrame("Button", "AddUIzhichi", frame, "UIPanelButtonTemplate")
	zhichi:SetText("赞助")
	zhichi:SetWidth(92)
	zhichi:SetHeight(24)
	zhichi:SetPoint("TOPLEFT", 330, 25)
	zhichi:SetScript("OnClick", function()
		 ToggleFrame(zhichiFrame);
	end)
	local pcrl = CreateFrame("Button", "AddUIpcrl", frame, "UIPanelButtonTemplate")
	pcrl:SetText("重载")
	pcrl:SetWidth(92)
	pcrl:SetHeight(22)
	pcrl:SetPoint("BOTTOMRIGHT", -200, -36)
	pcrl:SetScript("OnClick", function()
		 ReloadUI()
	end)
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMLEFT", 40, -30)
	qqun:SetText("斗鱼:323075       QQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	
	local ppca = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ppca:SetPoint("TOPRIGHT", -5, -5)
	ppca:SetText("|cff00FF7F/pca|r快速打开此界面")
	ppca:SetJustifyH("RIGHT")
	ppca:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')

	auraname = newFont(16, -15 , frame, "TOPLEFT", frame, "TOPLEFT", "光环白名单", 30)
	if not frame.SecondText then 
		frame.SecondText = frame:CreateFontString(nil, "OVERLAY");
	end
	frame.SecondText:SetFontObject("GameFontHighlight");
	frame.SecondText:SetPoint("TOPLEFT", frame, "TOPLEFT", 16, -50 );   
	-- frame.AuraText:SetParent(frame)    
	frame.SecondText:SetJustifyH("LEFT")
	frame.SecondText:SetText("光环白名单不仅作用于姓名版的光环显示，同样作用于个人资源条\n光环指自己或者目标的buff/debuff\n法术ID是buff/debuff的法术ID,并非技能ID\n最多支持20个光环");
	hidebuffc = newCheckbox(200, -20, frame, "|cffFF0000隐藏所有光环|r", "|cffFF0000隐藏姓名版上的所有光环(除非你有特殊需求,否则不要开启此项)|r", frame, "hidebuff")
	
	--blacklistc = newCheckbox(25, -270, frame, "|cffFFFF00反向白名单|r", "打开此项后白名单变为黑名单,名单内的光环都不会显示", frame, "blacklist")
	
	myplatebuffc = newCheckbox(25, -320, frame, "个人资源光环", "屏幕中间个人资源条上的buff", frame, "myplatebuff")
	bufftextc = newCheckbox(25, -350, frame, "光环冷却文字", "|cff00FF7F需要同时开启esc-界面-动作条-冷却时间|r", frame, "bufftext")
	buffz = newSlider(25, -410, "buff大小", 20, 40, 25, 1, " ",  " ","buff大小","血条上buff大小,20为暴雪默认数值", frame, frame, "buffz", "%d")
	buffz:HookScript("OnValueChanged", function ( ... ) PlateOPT() end)
	buffoffset = newSlider(25, -450, "buff上下偏移", -20, 20, 0, 1, " ",  " ","buff上下偏移","血条上buff位置上下调整", frame, frame, "buffoffset", "%d")
	buffoffset:HookScript("OnValueChanged", function ( ... ) PlateOPT() end)
	SelfScale = newSlider(25, -490, "个人资源条大小", 0.1, 2, 1, 0.1, " ",  " ","|cff00FF7F个人资源条大小|r","|cff00FF7F本项属于Cvar,卸载插件依然生效,暴雪默认1|r", frame, frame, "SelfScale", "%.1f", "nameplateSelfScale")

	
	local DctSavedAura = PlateColorDB["DctAura"]
	frame.DctDisplay = table_copy(DctSavedAura)

	if not frame.AuraText then 
		frame.AuraText = frame:CreateFontString(nil, "OVERLAY");
		frame.AuraText:SetFontObject("GameFontHighlight");
		frame.AuraText:SetPoint("TOPLEFT", frame, "TOPLEFT", 60, -120 );   
		frame.AuraText:SetParent(frame)
		frame.AuraText:SetFont("fonts\\ARHei.ttf", 20, "OUTLINE")
		frame.AuraText:SetText("|cff00FF7F法术ID|r");
	end

	local EditText = nil 
	if not frame.EditBox then 
		frame.EditBox = CreateFrame("EditBox", nil, frame, "InputBoxTemplate");
		frame.EditBox:SetPoint("TOPLEFT", frame, "TOPLEFT", 45 , -150);  
		frame.EditBox:SetSize(100,10);
		frame.EditBox:SetAutoFocus();
		frame.EditBox:SetMaxLetters(9);
		-- frame.EditBox:SetNumeric(true);
		--UIConfig.AuraEditBox:SetPassword(true);
		--UIConfig.EditBox1:Insert('Rgg'); 
		frame.EditBox:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); 
		    ChatFrame1EditBox:SetFocus(); 
			-- print (self:GetText());   --todo输出的位置在俩函数前面会出问题
		end);
		frame.EditBox:SetScript("OnChar", function (self, text)
			EditText = self:GetText()
		end);
	end


	local nilFrame = CreateFrame("Frame")

	local function ClearAuraPanel()
		if dctTempIcon then 
			for k, v in pairs(dctTempIcon) do
				v:Hide()
				dctTempIcon[k]:Hide()
				dctTempIcon[k]:SetParent(nilFrame)
				dctTempIcon[k] = nil 
			end
		end
		if dctTempInfo then
			for k, v in pairs(dctTempInfo) do
				v:Hide()
				dctTempInfo[k]:Hide()
				dctTempInfo[k]:SetParent(nilFrame)
				dctTempInfo[k] = nil 
			end
		end
	end

	if not frame.AuraAdd then 
		frame.AuraAdd = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
		frame.AuraAdd:SetPoint("TOPLEFT", frame, "TOPLEFT", 33 , -170);  
		frame.AuraAdd:SetSize(120,40);
		frame.AuraAdd:SetText("添加-->")
		frame.AuraAdd:SetNormalFontObject("GameFontNormalLarge");
		frame.AuraAdd:SetHighlightFontObject("GameFontHighlightLarge");
		-- frame.AuraAdd.parent = frame
		frame.AuraAdd:SetScript("OnClick", function(self, button, down)
			if GetTrueNum(frame.DctDisplay) >= 20 then return end 
			local SpellID = tonumber(EditText)
			if frame.DctDisplay[SpellID] then return end
			if not SpellID then return end 
			local SpellName, _ = GetSpellInfo(SpellID)
			if not SpellName then return end
			frame.DctDisplay[SpellID] = true
			PlateColorDB["DctAura"] = frame.DctDisplay
			SetSpell(frame.DctDisplay)

			end)
	end

	if not frame.Auradel then 
		frame.Auradel = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
		frame.Auradel:SetPoint("TOPLEFT", frame, "TOPLEFT", 33 , -220);  
		frame.Auradel:SetSize(120,40);
		frame.Auradel:SetText("移除<--")
		frame.Auradel:SetNormalFontObject("GameFontNormalLarge");
		frame.Auradel:SetHighlightFontObject("GameFontHighlightLarge");
		frame.Auradel:SetScript("OnClick", function(self, button, down)
			local SpellID = tonumber(EditText)
			if not frame.DctDisplay[SpellID] then return end 
			frame.DctDisplay[SpellID] = false
			PlateColorDB["DctAura"] = frame.DctDisplay
			SetSpell(frame.DctDisplay)
			end)
	end
		
	function SetSpell(dctTest)
		ClearAuraPanel()
		dctTempIcon = {}
		dctTempInfo = {}
		local dctKeys = table_keys(dctTest)
		local iLeng = table_leng(dctTest)
		local t = 1
		local hor = 1 
		
		for i=1 , iLeng do
			local iSpellID = dctKeys[i]  
			if dctTest[iSpellID] then
				--print ("创建第"..t.."个图标"..iSpellID)
				
				local name , _ , icon,_ ,_ ,_ ,_ = GetSpellInfo(iSpellID)
				if icon == nil then icon = 237555 end
				if t >10 then
					hor = 2
					t = 1
				end
				frame.Spell = frame:CreateFontString('myarua', "OVERLAY");
				frame.Spell:SetFontObject("GameFontHighlight");
				frame.Spell:SetPoint("TOPLEFT", frame, "TOPLEFT", 200*hor, -40*t -90 );   --锚点, 位置, 偏移
				
				frame.Spell:SetParent(frame)    --todo 这写"SecondPage"和这个local 变量都可以,为什么在上面overlay后面写父会bug
				frame.Spell:SetText("|T"..icon ..":18|t "..name);
				
				--------------------
				
				frame.SpellMouseInfo = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
				frame.SpellMouseInfo:SetPoint("TOPLEFT", frame, "TOPLEFT", 200*hor , -40*t - 90);  
				frame.SpellMouseInfo.ID = iSpellID
				
				t = t + 1;
				
				frame.SpellMouseInfo:SetSize(70,25);
				frame.SpellMouseInfo:SetText(nil)
				frame.SpellMouseInfo:SetAlpha(0);

				frame.SpellMouseInfo:SetScript("OnEnter", function(self, button, down)
					GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
					-- GameTooltip:AddDoubleLine(L["AuraIDTT"], tostring(iSpellID), 1, 1, 0, 1 ,1, 1);
					GameTooltip:SetSpellByID(iSpellID)
					GameTooltip:AppendText("   ".."|cff00FF7F".."光环ID:"..tostring(iSpellID).."|r")
					GameTooltip:Show()
				end)
				
				frame.SpellMouseInfo:SetScript("OnLeave", function(self, button, down)
					GameTooltip:Hide()
				end)
		

				dctTempIcon[i] = frame.Spell
				dctTempInfo[i] = frame.SpellMouseInfo
				-- table.insert(dctTempIcon, frame.Spell)
				-- table.insert(dctTempInfo, frame.SpellMouseInfo)
			end
		
		
		end

		--UIConfig.Spell1 = UIConfig:CreateFontString(nil, "OVERLAY");
		--UIConfig.Spell1:SetFontObject("GameFontHighlight");
		--UIConfig.Spell1:SetPoint("TOPLEFT", UIConfig, "TOPLEFT", 160, -40 );   --锚点, 位置, 偏移
		--UIConfig.Spell1:SetParent(UISecondPage)    --todo 这写"SecondPage"和这个local 变量都可以,为什么在上面overlay后面写父会bug
		--UIConfig.Spell1:SetText("|T236176:18|t 奇美拉射击");
	end

	SetSpell(frame.DctDisplay)

	if not frame.sInfo2 then 
	frame.sInfo2 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	end
	frame.sInfo2:SetPoint("BOTTOMRIGHT", -10, 10)
	-- frame.sInfo2:SetText("修改光环后点确定会引起界面重载")
	frame.sInfo2:SetJustifyH("RIGHT")
frame:SetScript("OnShow", nil)
end)

local blackTempIcon = {}
local blackTempInfo = {}

myGUI.frame3:SetScript("OnShow", function(frame)
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("恢复默认并重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 442, 25)
	clear:SetScript("OnClick", function()
		PlateColorDB = DefaultDB
		ReloadUI()
	end)
	local zhichi = CreateFrame("Button", "AddUIzhichi", frame, "UIPanelButtonTemplate")
	zhichi:SetText("赞助")
	zhichi:SetWidth(92)
	zhichi:SetHeight(24)
	zhichi:SetPoint("TOPLEFT", 330, 25)
	zhichi:SetScript("OnClick", function()
		 ToggleFrame(zhichiFrame);
	end)
	local pcrl = CreateFrame("Button", "AddUIpcrl", frame, "UIPanelButtonTemplate")
	pcrl:SetText("重载")
	pcrl:SetWidth(92)
	pcrl:SetHeight(22)
	pcrl:SetPoint("BOTTOMRIGHT", -200, -36)
	pcrl:SetScript("OnClick", function()
		 ReloadUI()
	end)
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMLEFT", 40, -30)
	qqun:SetText("斗鱼:323075       QQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	local ppcb = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	ppcb:SetPoint("TOPRIGHT", -5, -5)
	ppcb:SetText("|cff00FF7F/pcb|r快速打开此界面")
	ppcb:SetJustifyH("RIGHT")
	ppcb:SetFont(STANDARD_TEXT_FONT, 12, 'OUTLINE')

	auraname = newFont(16, -15 , frame, "TOPLEFT", frame, "TOPLEFT", "|cff3399FF光环黑名单|r", 30)
	if not frame.SecondText then 
		frame.SecondText = frame:CreateFontString(nil, "OVERLAY");
	end
	frame.SecondText:SetFontObject("GameFontHighlight");
	frame.SecondText:SetPoint("TOPLEFT", frame, "TOPLEFT", 16, -50 );   
	-- frame.AuraText:SetParent(frame)    
	frame.SecondText:SetJustifyH("LEFT")
	frame.SecondText:SetText("把你不想在血条上显示的光环ID写在这里,然后添加,你就看不到它们了\n如果你在白名单和黑名单共同添加一个光环,那么他不会显示");
	
	local blackSavedAura = PlateColorDB["blackAura"]
	frame.blackDisplay = table_copy(blackSavedAura)

	if not frame.AuraText then 
		frame.AuraText = frame:CreateFontString(nil, "OVERLAY");
		frame.AuraText:SetFontObject("GameFontHighlight");
		frame.AuraText:SetPoint("TOPLEFT", frame, "TOPLEFT", 60, -120 );   
		frame.AuraText:SetParent(frame)
		frame.AuraText:SetFont("fonts\\ARHei.ttf", 20, "OUTLINE")
		frame.AuraText:SetText("|cff3399FF法术ID|r");
	end

	local blackEditText = nil 
	if not frame.EditBox then 
		frame.EditBox = CreateFrame("EditBox", nil, frame, "InputBoxTemplate");
		frame.EditBox:SetPoint("TOPLEFT", frame, "TOPLEFT", 45 , -150);  
		frame.EditBox:SetSize(100,10);
		frame.EditBox:SetAutoFocus();
		frame.EditBox:SetMaxLetters(9);
		-- frame.EditBox:SetNumeric(true);
		--UIConfig.AuraEditBox:SetPassword(true);
		--UIConfig.EditBox1:Insert('Rgg'); 
		frame.EditBox:SetScript("OnEnterPressed", function(self)
			self:ClearFocus(); 
		    ChatFrame1EditBox:SetFocus(); 
			-- print (self:GetText());   --todo输出的位置在俩函数前面会出问题
		end);
		frame.EditBox:SetScript("OnChar", function (self, text)
			blackEditText = self:GetText()
		end);
	end


	local blacknilFrame = CreateFrame("Frame")

	local function blackClearAuraPanel()
		if blackTempIcon then 
			for k, v in pairs(blackTempIcon) do
				v:Hide()
				blackTempIcon[k]:Hide()
				blackTempIcon[k]:SetParent(blacknilFrame)
				blackTempIcon[k] = nil 
			end
		end
		if blackTempInfo then
			for k, v in pairs(blackTempInfo) do
				v:Hide()
				blackTempInfo[k]:Hide()
				blackTempInfo[k]:SetParent(blacknilFrame)
				blackTempInfo[k] = nil 
			end
		end
	end

	if not frame.AuraAdd then 
		frame.AuraAdd = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
		frame.AuraAdd:SetPoint("TOPLEFT", frame, "TOPLEFT", 33 , -170);  
		frame.AuraAdd:SetSize(120,40);
		frame.AuraAdd:SetText("添加-->")
		frame.AuraAdd:SetNormalFontObject("GameFontNormalLarge");
		frame.AuraAdd:SetHighlightFontObject("GameFontHighlightLarge");
		-- frame.AuraAdd.parent = frame
		frame.AuraAdd:SetScript("OnClick", function(self, button, down)
			if GetTrueNum(frame.blackDisplay) >= 20 then return end 
			local blackSpellID = tonumber(blackEditText)
			if frame.blackDisplay[blackSpellID] then return end
			if not blackSpellID then return end 
			local SpellName, _ = GetSpellInfo(blackSpellID)
			if not SpellName then return end
			frame.blackDisplay[blackSpellID] = true
			PlateColorDB["blackAura"] = frame.blackDisplay
			blackSetSpell(frame.blackDisplay)

			end)
	end

	if not frame.Auradel then 
		frame.Auradel = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
		frame.Auradel:SetPoint("TOPLEFT", frame, "TOPLEFT", 33 , -220);  
		frame.Auradel:SetSize(120,40);
		frame.Auradel:SetText("移除<--")
		frame.Auradel:SetNormalFontObject("GameFontNormalLarge");
		frame.Auradel:SetHighlightFontObject("GameFontHighlightLarge");
		frame.Auradel:SetScript("OnClick", function(self, button, down)
			local blackSpellID = tonumber(blackEditText)
			if not frame.blackDisplay[blackSpellID] then return end 
			frame.blackDisplay[blackSpellID] = false
			PlateColorDB["blackAura"] = frame.blackDisplay
			blackSetSpell(frame.blackDisplay)
			end)
	end
		
	function blackSetSpell(blackTest)
		blackClearAuraPanel()
		blackTempIcon = {}
		blackTempInfo = {}
		local blackKeys = table_keys(blackTest)
		local blackiLeng = table_leng(blackTest)
		local blackt = 1
		local blackhor = 1 
		
		for i=1 , blackiLeng do
			local iblackSpellID = blackKeys[i]  
			if blackTest[iblackSpellID] then
				--print ("创建第"..blackt.."个图标"..iblackSpellID)
				
				local name , _ , icon,_ ,_ ,_ ,_ = GetSpellInfo(iblackSpellID)
				if icon == nil then icon = 237555 end
				if blackt >10 then
					blackhor = 2
					blackt = 1
				end
				frame.Spell = frame:CreateFontString('myarua', "OVERLAY");
				frame.Spell:SetFontObject("GameFontHighlight");
				frame.Spell:SetPoint("TOPLEFT", frame, "TOPLEFT", 200*blackhor, -40*blackt -90 );   --锚点, 位置, 偏移
				
				frame.Spell:SetParent(frame)    --todo 这写"SecondPage"和这个local 变量都可以,为什么在上面overlay后面写父会bug
				frame.Spell:SetText("|T"..icon ..":18|t "..name);
				
				--------------------
				
				frame.SpellMouseInfo = CreateFrame("Button", nil, frame, "GameMenuButtonTemplate");
				frame.SpellMouseInfo:SetPoint("TOPLEFT", frame, "TOPLEFT", 200*blackhor , -40*blackt - 90);  
				frame.SpellMouseInfo.ID = iblackSpellID
				
				blackt = blackt + 1;
				
				frame.SpellMouseInfo:SetSize(70,25);
				frame.SpellMouseInfo:SetText(nil)
				frame.SpellMouseInfo:SetAlpha(0);

				frame.SpellMouseInfo:SetScript("OnEnter", function(self, button, down)
					GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
					GameTooltip:SetSpellByID(iblackSpellID)
					GameTooltip:AppendText("   ".."|cff00FF7F".."光环ID:"..tostring(iblackSpellID).."|r")
					GameTooltip:Show()
				end)
				
				frame.SpellMouseInfo:SetScript("OnLeave", function(self, button, down)
					GameTooltip:Hide()
				end)
		

				blackTempIcon[i] = frame.Spell
				blackTempInfo[i] = frame.SpellMouseInfo

			end
		
		
		end
	end

	blackSetSpell(frame.blackDisplay)

	if not frame.sInfo3 then 
	frame.sInfo3 = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	end
	frame.sInfo3:SetPoint("BOTTOMRIGHT", -10, 10)
	frame.sInfo3:SetJustifyH("RIGHT")

frame:SetScript("OnShow", nil)
end)


InterfaceOptions_AddCategory(myGUI.frame1)
InterfaceOptions_AddCategory(myGUI.frame2)
InterfaceOptions_AddCategory(myGUI.frame3)

SLASH_PlateColor1 = "/pc"
SLASH_PlateColor2 = "/platecolor"
SlashCmdList["PlateColor"] = function() 
    InterfaceOptionsFrame_OpenToCategory(myGUI.frame1)
	InterfaceOptionsFrame_OpenToCategory(myGUI.frame1)
end
SLASH_PlateColorAura1 = "/pca"
SlashCmdList["PlateColorAura"] = function() 
    InterfaceOptionsFrame_OpenToCategory(myGUI.frame2)
	InterfaceOptionsFrame_OpenToCategory(myGUI.frame2)
end
SLASH_PlateColorBAura1 = "/pcb"
SlashCmdList["PlateColorBAura"] = function() 
    InterfaceOptionsFrame_OpenToCategory(myGUI.frame3)
	InterfaceOptionsFrame_OpenToCategory(myGUI.frame3)
end
